#include "sxBoot.h"
#include "sxDebug.h"
#include "sxConsole.h"

void SxDbgDumpStack(sx_uint32* sp, sx_uint32 depth) {
	sx_eColors fg;

	SxConGetColor(&fg, SX_NULL);
	SxConSetTextColor(ecBrightGreen);

	SxConPrint("\nStack Dump from %p, %d items:\n", sp, depth);

	while(depth-- > 0) {
		SxConPrint(" * [%P]: [%P]\n", sp, *sp);
		++sp;
	}

	SxConSetTextColor(fg);
}

void SxDbgDumpCurrentStack(sx_uint32 depth) {
	__asm {
		mov eax, depth
		push eax
		mov eax, esp
		add eax, 16
		push eax
		call SxDbgDumpStack
		add esp, 8
	}
}
