#ifndef __SXINTHANDLERS_H__
#define __SXINTHANDLERS_H__

#include "sxTypes.h"

typedef SX_ALIGN(1) struct {
	struct {
		sx_uint32 ds;
		sx_uint32 edi;
		sx_uint32 esi;
		sx_uint32 ebp;
		sx_uint32 esp;
		sx_uint32 ebx;
		sx_uint32 edx;
		sx_uint32 ecx;
		sx_uint32 eax;
	} handler;

	struct {
		sx_uint32 number;
		sx_uint32 code;
	} interupt;

	struct {
		sx_uint32 eip;
		sx_uint32 cs;
		sx_uint32 eflags;
	} source;
} sx_interupt_info_t;

typedef void (*sx_isr_t)(sx_interupt_info_t);

void SxIntHandlersInit();

void SxIntHandlerSet(sx_uint8 idx, sx_isr_t isr);
void SxIntHandlerClear(sx_uint8 idx);

void SxIrqHandlerSet(sx_uint8 idx, sx_isr_t isr);
void SxIrqHandlerClear(sx_uint8 idx);

/* Exceptions */
void SxIntHandleDivide(sx_interupt_info_t);

/* General */
void SxIntUnhandledInt(sx_interupt_info_t);
void SxIntUnhandledIRQ(sx_interupt_info_t);

#endif