#ifndef __SXINTERUPTS_H__
#define __SXINTERUPTS_H__

#include "sxTypes.h"

#define SX_INTERUPT_COUNT	48
#define SX_IRQ_BEGIN		32

#define SX_PIC_MASTER_CMD	0x20
#define SX_PIC_MASTER_DAT	0x21
#define SX_PIC_SLAVE_CMD	0xA0
#define SX_PIC_SLAVE_DAT	0xA1

#define SX_PIC_EOI			0x20

/* PIC initialization control words */
#define SX_PIC_ICW1_IC4		(1)
#define SX_PIC_ICW1_SINGLE	(1 << 1)
#define SX_PIC_ICW1_INTERV4	(1 << 2)
#define SX_PIC_ICW1_LEVEL	(1 << 3)
#define SX_PIC_ICW1_INIT	(1 << 4)

#define SX_PIC_ICW4_8086	(1)
#define SX_PIC_ICW4_AUTOEOI	(1 << 1)
#define SX_PIC_ICW4_BUF_MST	(1 << 2)
#define SX_PIC_ICW4_BUF		(1 << 3)
#define SX_PIC_ICW4_NESTED	(1 << 4)

void SxInteruptsInit();

void SxInteruptsEnable();
void SxInteruptsDisable();

void SxIntSetInteruptGate(sx_uint8 idx, sx_uint32 base, sx_uint16 sel, sx_uint8 dpl);
void SxIntClearAnyGate(sx_uint8 idx);

void SxMaskPICInterupt(sx_uint8 idx);
void SxUnmaskPICInterupt(sx_uint8 idx);

void SxMaskAllPICInterupts();
void SxUnmaskAllPICInterupts();

#endif