#ifndef __SXTYPES_H__
#define __SXTYPES_H__

typedef char			sx_int8;
typedef unsigned char	sx_uint8;
typedef short			sx_int16;
typedef unsigned short	sx_uint16;
typedef int				sx_int32;
typedef unsigned int	sx_uint32;
typedef char*			sx_va_list;

#define EMIT_BYTE(x)	__asm _emit (x)
#define EMIT_WORD(x)	__asm _emit (x) & 0xff \
						__asm _emit (x) >> 8 & 0xff
#define EMIT_DWORD(x)	__asm _emit (x) & 0xff \
						__asm _emit (x) >> 8 & 0xff \
						__asm _emit (x) >> 16 & 0xff \
						__asm _emit (x) >> 24 & 0xff

#define SX_NAKED		__declspec(naked)
#define SX_NORETURN		__declspec(noreturn)
#define SX_ALIGN(x)		__declspec(align(x))
#define SX_NULL			((void*)0)

#define SX_BITTEST(x, b)((x) & (1 << (b)))

#define SX_INTSIZEOF(x)	((sizeof(x) + sizeof(int) - 1) & ~(sizeof(int) - 1))
#define sx_va_start(x,v)(x = (sx_va_list)&(v) + SX_INTSIZEOF(v) )
#define sx_va_arg(x,t)	(*(t*)((x += SX_INTSIZEOF(t)) - SX_INTSIZEOF(t)))
#define sx_va_end(x)	(x = (sx_va_list)0)

#endif